import cv2
import numpy as np

img = cv2.imread('current.jpg',0)
img = cv2.medianBlur(img,5)
cimg = cv2.cvtColor(img,cv2.COLOR_GRAY2BGR)

height, width = img.shape
mheight = height / 2.0
mwidth  = width  / 2.0

print mheight, mwidth

try:
    hough_gradient = cv2.HOUGH_GRADIENT
except AttributeError:
    hough_gradient = cv2.cv.CV_HOUGH_GRADIENT

circles = cv2.HoughCircles(img,hough_gradient,1,20,
                            param1=50,param2=22,minRadius=10,maxRadius=35)

closest = 0
maxDistance = float('inf')
outPercentage = None

try:
    circles = np.uint16(np.around(circles))

    index = -1
    for i in circles[0,:]:

        index += 1
        print index, i
        x = i[0]
        y = i[1]
        r = i[2]
        # draw the outer circle
        cv2.circle(cimg,(x,y),r,(0,255,0),2)
        # draw the center of the circle
        cv2.circle(cimg,(x,y),2,(0,0,255),3)

        distance =  np.sqrt( (x - mwidth) ** 2 + (y - mheight) ** 2 )

        sampleRadius = r * 2
        samples = 100
        sampleVector = []

        try:
            for i in range(samples):
                sx = int( x + sampleRadius * np.cos(np.pi*i/samples) )
                sy = int( y - sampleRadius * np.sin(np.pi*i/samples) )
                sampleVector.append(img[sy][sx])
            percentage = str( (1.0-(float(np.argmin(sampleVector))/samples))*100 )
            print percentage

            if (distance < maxDistance):
                maxDistance = distance
                outPercentage = percentage
        except IndexError:
            print "The circle is too close to the edge of the image."

    if outPercentage is not None:
        with open('percentage.txt', 'w') as f:
            f.write( outPercentage )
            print "Picked " + outPercentage
        
except AttributeError:
    pass

cv2.imwrite('output.jpg', cimg)
#cv2.imshow('detected circles',cimg)
#cv2.waitKey(0)
#cv2.destroyAllWindows()

